package io.tswf.transmutations.transmute.injection.contexts

import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.meta.TransmutationMethodMetadata
import io.tswf.transmutations.transmute.util.CustomPayload
import io.tswf.transmutations.transmute.util.ICustomPayload
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CheckedMapConstructor
@CompileStatic
class TransmutationInjectionToMethodContext {
    TransmutationMethodMetadata transmutationMetadata
    MethodNode targetMethod
    ClassNode targetMethodOwner
    List<TransmutationInjectionToMethodAtInsnContext> perInsnContexts = new ArrayList<>()
    ICustomPayload customPayload = new CustomPayload()
}
