package io.tswf.transmutations.transmute.annotation;

import io.tswf.transmutations.common.annotation.ClassReference;
import io.tswf.transmutations.common.annotation.FieldDescription;
import io.tswf.transmutations.transmute.injection.points.FieldCallType;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface AtFieldCall {
    FieldDescription field();
    ClassReference owner();
    FieldCallType callType() default FieldCallType.ANY;
}
