package io.tswf.transmutations.transmute.exception

import groovy.transform.CompileStatic

@CompileStatic
class TransmutationReturnValueCastException extends RuntimeException {
    TransmutationReturnValueCastException(Throwable cause, Object notCastedValue, String transmutationInfo) {
        super("Exception occurred while trying to cast new local variable value ${notCastedValue} from transmutation ${transmutationInfo}", cause)
    }
}
